/*
*
*
*   Author: Christian Sarmoria   Base code from CPS616 course.
*
*   Date:   03-07-99
*
*   Course: CPS - 616 Project #3
*
*   File name: Client.java
*
*
*   The flow of the program is the following:
*
*   1- Connect to ORACLE server
*   2- Perfomr searchs, view records, add records, delete records
*   3- Close connection with ORACLE server
*
*
*    Client.java applet for connecting to Oracle database.
*    Uses file myDatabase.java
*    Errors and informational messages can be viewed on the Java Console.
*/


// Importing from JDK

import java.io.*;
import java.awt.*;
import java.net.*;
import java.rmi.*;
import java.rmi.server.*;
/*
import java.awt.*;
import java.rmi.*;
//import java.awt.Image;
//import java.net.*;
//import java.net.URL;
import java.io.*;
import java.applet.*;
import java.awt.event.ActionListener;
import java.awt.event.ActionEvent;
import java.lang.String;
//import java.awt.Button;


*/

// Main applet class
public class aServer extends UnicastRemoteObject implements DBCRemote {

  public myDatabase database;
//  public myDatabase database = new myDatabase();
    private String objName;
    private String code;
    private String name;
    private String released;
    private String madein;
    private String picture;
    private String baseprice;

   public aServer(String s) throws java.rmi.RemoteException {
        super();
        objName = s;
        database = new myDatabase();
    }

    public void search(String a) throws java.rmi.RemoteException {

        StringBuffer asb = new StringBuffer();
        StringBuffer bsb = new StringBuffer();
        StringBuffer csb = new StringBuffer();
        StringBuffer dsb = new StringBuffer();
        StringBuffer esb = new StringBuffer();
        StringBuffer fsb = new StringBuffer();

        database.find(a, asb, bsb, csb,dsb, esb, fsb );
        code = asb.toString();
        name = bsb.toString();
        released = csb.toString();
        madein = dsb.toString();
        picture = esb.toString();
        baseprice = fsb.toString();
        System.out.println("got back from db: ");
        System.out.println("Code: " + code);
        System.out.println("Name: " + name);
        System.out.println("Released: " + released);
    }

/*
  public void advance() {
    StringBuffer countryname = new StringBuffer();
    StringBuffer countrycapital = new StringBuffer();
    StringBuffer countrypopulation = new StringBuffer();
    StringBuffer countrycontinent = new StringBuffer();
    StringBuffer countrysecure = new StringBuffer();
    StringBuffer continenthemisphere = new StringBuffer();
    // move to next record
    database.move("a", countryname, countrycapital, countrypopulation,countrycontinent, countrysecure, continenthemisphere);
    System.out.println("Moved next from db: " + countryname.toString());
//    dp.showResult(countryname.toString(), countrycapital.toString(), countrypopulation.toString(), countrycontinent.toString(), countrysecure.toString(), continenthemisphere.toString(), "No more records in query.");
  }
*/

  // Add new record as entered by user in the the white central panel fields
/*  public void addnewrecord() {
    StringBuffer countryname = new StringBuffer();
    StringBuffer countrycapital = new StringBuffer();
    StringBuffer countrypopulation = new StringBuffer();
    StringBuffer countrycontinent = new StringBuffer();
    StringBuffer countrysecure = new StringBuffer();
    // perform record addition
    database.addrecord(dp.field1.getText(), dp.field2.getText(), dp.field3.getText(), dp.field4.getText(), dp.field5.getText());
    System.out.println("Added into db: " + countryname.toString());
 //   dp.connMessage.setText("Record Addition performed.");
  }


  // Deletes record by country name, as entered by user
  public void deleterecord() {
    StringBuffer countryname = new StringBuffer();
    StringBuffer countrycapital = new StringBuffer();
    StringBuffer countrypopulation = new StringBuffer();
    StringBuffer countrycontinent = new StringBuffer();
    StringBuffer countrysecure = new StringBuffer();
    // performs record deletion
    database.deleterecord(dp.field1.getText());
    System.out.println("Deleted from db: " + countryname.toString());
 //   dp.connMessage.setText("Record Deletion performed.");
  }

*/



    public String getCode() throws java.rmi.RemoteException {
        return code;
    }

    public String getName() throws java.rmi.RemoteException {
        return name;
    }

    public String getReleased() throws java.rmi.RemoteException {
       return released;
    }

    public String getMadein() throws java.rmi.RemoteException {
       return madein;
    }

    public String getPicture() throws java.rmi.RemoteException {
       return picture;
    }

    public String getBaseprice() throws java.rmi.RemoteException {
       return baseprice;
    }

    public void open() throws java.rmi.RemoteException {
        database.open();
        System.out.println("OPEN DATABASE");
    }

    public void close() throws java.rmi.RemoteException {
        database.close();
        System.out.println("CLOSE DATABASE");
    }

  public static void main(String[] args) {

    // Create and install the security manager
    System.setSecurityManager(new RMISecurityManager());

    try {
            aServer obj = new aServer("DBCServer");
            Naming.rebind("//jojo.npac.syr.edu:2923/PlaneServer", obj);
            System.out.println("Server created and bound in the registry to the name DBCServer");
    }
    catch (Exception ex) {
      System.err.println("Plane Server: Exception-> " + ex);
      ex.printStackTrace();
    }
  }
}

// Christian Sarmoria.
// cgsarmor@mailbox.syr.edu


